Views rely on the serialize() and deserialize() API to save and restore.
Serialize & Deserialize
Serialize current supports the following data:
Fields
Options
Filter
Sort
Layout
PivotTable Position
Theme
Interface
API
Sample Code
PivotTableViewManager
The PivotTableViewManager is used to add, delete, modify, and check Pivot Table Views.
The PivotTableViewManager and PivotTable have a one-to-one relationship, and it is initialized in the PivotTable constructor.
Interface
API
If you set "viewList" to visible in the pivot panel, you can use it to control the views of a PivotTable. You can add, remove, and apply the views with the view list section at the bottom of the panel.
You can follow these steps:
Click the "▼" button, which will show the views list dialog.
Click the "x" button on the right of each item in the views list dialog, which will remove the view.
Enter the View Name in the input dialog, and then click the "+" button to add the View.
If there is no value in the input dialog, the default name will be used instead.
Click one item in the views list dialog, and the view name will show in the input dialog.
Click the "√" button, which will apply the view with this name (with the Deserialize() API of PivotTable).
window.onload = function () {
var spread = new GC.Spread.Sheets.Workbook(_getElementById('ss'), { sheetCount: 2 });
initSpread(spread);
var pivotLayoutSheet = spread.getSheet(0);
initPivotTable(pivotLayoutSheet);
};
function initSpread(spread) {
spread.suspendPaint();
var sheet = spread.getSheet(1);
sheet.name("DataSource");
sheet.setRowCount(117);
sheet.setColumnWidth(0, 120);
sheet.getCell(-1, 0).formatter("YYYY-mm-DD");
sheet.getRange(-1,4,0,2).formatter("$ #,##0");
let table = sheet.tables.add('tableSales', 0, 0, 117, 6);
for(let i=2;i<=117;i++)
{
sheet.setFormula(i-1,5,'=D'+i+'*E'+i)
}
table.style(GC.Spread.Sheets.Tables.TableThemes["none"]);
sheet.setArray(0, 0, pivotSales);
var sheet0 = spread.getSheet(0);
sheet0.name("PivotLayout");
sheet0.setValue(0, 1, "Switch the build-in views in the pivot panel view list.");
spread.resumePaint();
}
function initPivotTable(sheet) {
var myPivotTable = sheet.pivotTables.add("myPivotTable", "tableSales", 2, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light8);
myPivotTable.suspendLayout();
var groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }] };
myPivotTable.group(groupInfo);
var emptyPT = "Empty Pivot Table";
myPivotTable.views.save(emptyPT);
// Quarterly Report
myPivotTable.options.showRowHeader = true;
myPivotTable.options.showColumnHeader = true;
myPivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField);
myPivotTable.add("Quarters (date)", "Qt", GC.Spread.Pivot.PivotTableFieldType.columnField);
myPivotTable.add("total", "Totals", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
let styleItem = {
dataOnly: true,
references: [{
fieldName: "Qt",
items: ["Qtr3", "Qtr4"]
}]
};
let style1 = new GC.Spread.Sheets.Style();
style1.formatter = '0%';
myPivotTable.setStyle(styleItem, style1);
myPivotTable.views.save("Quarterly Report");
// Quantity Details
myPivotTable.views.apply(emptyPT);
myPivotTable.theme(GC.Spread.Pivot.PivotTableThemes.medium1);
myPivotTable.options.insertBlankLineAfterEachItem = true;
myPivotTable.options.mergeItem = true
myPivotTable.layoutType(GC.Spread.Pivot.PivotTableLayoutType.tabular);
myPivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField);
myPivotTable.add("Quarters (date)", "Qt", GC.Spread.Pivot.PivotTableFieldType.columnField);
myPivotTable.add("quantity", "Totals", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
let style2 = new GC.Spread.Sheets.Style();
style1.formatter = '#,##0';
myPivotTable.setStyle(styleItem, style2);
myPivotTable.views.save("Car Quantity Details");
// John Cars Report
myPivotTable.views.apply(emptyPT);
myPivotTable.options.subtotalPosition = 0;
myPivotTable.layoutType(GC.Spread.Pivot.PivotTableLayoutType.compact);
myPivotTable.theme(GC.Spread.Pivot.PivotTableThemes.light14);
myPivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField);
myPivotTable.add("car", "Cars", GC.Spread.Pivot.PivotTableFieldType.columnField);
myPivotTable.add("Quarters (date)", "Qt", GC.Spread.Pivot.PivotTableFieldType.rowField);
myPivotTable.add("total", "Totals", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
var labelFilter = {textItem: {isAll: false, list: ["John"]}};
myPivotTable.labelFilter("Salesperson", labelFilter);
let style3 = new GC.Spread.Sheets.Style();
style1.formatter = '$ #,##0';
myPivotTable.setStyle(styleItem, style3);
myPivotTable.views.save("John Cars Report");
myPivotTable.views.apply("Quarterly Report");
new GC.Spread.Pivot.PivotPanel("myPivotPanel", myPivotTable, document.getElementById("panel"));
myPivotTable.resumeLayout();
myPivotTable.autoFitColumn();
}
function _getElementById(id) {
return document.getElementById(id);
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-shapes/dist/gc.spread.sheets.shapes.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-pivot-addon/dist/gc.spread.pivot.pivottables.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/data/pivot-data.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script>
<script src="app.js" type="text/javascript"></script>
<link rel="stylesheet" type="text/css" href="styles.css">
</head>
<body>
<div class="sample-tutorial">
<div id="ss" class="sample-spreadsheets"></div>
<div class="sample-panel">
<div id="panel"></div>
</div>
</div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
}
.sample-spreadsheets {
width: calc(100% - 300px);
height: 100%;
overflow: hidden;
float: left;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
overflow: hidden;
}
.sample-panel {
float: right;
width: 300px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.gc-panel {
padding: 10px;
background-color: rgb(230, 230, 230);
}
#panel {
position: absolute;
right: 0;
width: 300px;
height: 100%;
top: 0;
}
#app {
height: 100%;
}

Pivot View Manager

The Pivot View Manager can be used to manage the saved views of a pivot table. It allows you to quickly access any saved view of the pivot table at a certain point in time. You can add, delete and modify the views in the pivot view manager.

Select a saved view from the 'Views' dropdown at the bottom of the pivot table panel then press the right checkmark next to it to change the view.

Description
app.component.ts
index.html
app.component.html
styles.css
Copy to CodeMine

Views rely on the serialize() and deserialize() API to save and restore.

Serialize & Deserialize

Serialize current supports the following data:

  • Fields
  • Options
  • Filter
  • Sort
  • Layout
  • PivotTable Position
  • Theme

Interface

interface GC.Spread.Pivot.ISerializeInfo
{
    layoutType?: PivotTableLayoutType;
    options?: object;
    valuePosition?: GC.Pivot.IDataPosition;
    pivotTablePosition?: [number, number];
    fieldsInfo?: GC.Spread.Pivot.ISerializeFieldInfo[][];
}

interface GC.Spread.Pivot.ISerializeFieldInfo {
    sourceName: string;
    displayName: string;
    index: number;
    subtotal?:  GC.Pivot.SubtotalType;
    labelFilter?:  GC.Spread.Pivot.IPivotTextFilterInfo | GC.Spread.Pivot.IPivotConditionFilterInfo;
    valueFilter?:  GC.Spread.Pivot.IPivotConditionFilterInfo;
    sortInfo?:  GC.Spread.Pivot.IPivotTableSortInfo;
}

API

///* function serialize (): GC.Spread.Pivot.ISerializeInfo
/**
* @description get serialized pivot table data
* @returns {GC.Spread.Pivot.ISerializeInfo} serialized pivot table data
*/
serialize (): GC.Spread.Pivot.ISerializeInfo

///* function deserialize (serializeInfo: GC.Spread.Pivot.ISerializeInfo)
/**
* @description restore serialized pivot table data to a existed pivot table
* @param {GC.Spread.Pivot.ISerializeInfo} serialized pivot table data
*/
deserialize (serializeInfo: GC.Spread.Pivot.ISerializeInfo)

Sample Code

    var spread = new GC.Spread.Sheets.workbook(document.getElementById("ss"),{sheetCount:3});
    var sourceSheet = spread.getSheet(0);
    var sheet = spread.getSheet(1);
    var sourceData = [["Date","Buyer","Type","Amount"],
                      ["01-Jan","Mom","Fuel",74],
                      ["15-Jan","Mom","Food",235],
                      ["17-Jan","Dad","Sports",20],
                      ["21-Jan","Kelly","Books",125]];
    sourceSheet.setArray(0, 0, sourceData );
    sourceSheet.tables.add('sourceData', 0, 0, 5, 4);
    var layout = GC.Spread.Pivot.PivotTableLayoutType.compact;
    var theme = GC.Spread.Pivot.PivotTableThemes.medium2;
    var pivotTable = sheet.pivotTables.add("pivotTable_1", 'sourceData', 1, 1, layout, theme, options);
    pivotTable.add("Buyer","Buyer",GC.Spread.Pivot.PivotTableFieldType.rowField);
    pivotTable.add("Type","Type",GC.Spread.Pivot.PivotTableFieldType.columnField);
    pivotTable.add("Amount","Sum of Amount",GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
    var serialization = pivotTable.serialize();
    pivotTable.remove('Type');
    pivotTable.deserialize(serialization);

PivotTableViewManager

The PivotTableViewManager is used to add, delete, modify, and check Pivot Table Views.

The PivotTableViewManager and PivotTable have a one-to-one relationship, and it is initialized in the PivotTable constructor.

Interface

interface IPivotTableView{
     name: string;
     config: GC.Spread.Pivot.ISerializeInfo;
}

API

GC.Spread.Pivot.PivotTable
///* class GC.Spread.Pivot.PivotTable.PivotTableViewManager(applyCallback: Function, saveCallback: Function)
/**
 * Represents a PivotTableViewManager.
 * @class
 */
views

GC.Spread.Pivot.PivotTable.PivotTableViewManager
/**
 * @description Add a view to pivot table views. A unique name is required when adding a view.
 * @param {string} view Indicates the view to add.
 * @example
 * var viewsManager = pivotTable.views;
 * viewsManager.add({
 *      name: 'config1',
 *      config: pivotTable.serialize()
 * });
 * viewsManager.get('config1');
 */
add(view:  GC.Spread.Pivot.IPivotTableView): boolean;
/**
 * @description  Add a view to pivot table views. A unique name is required when adding a view.
 * @param {string} name Indicates the name of view to save.
 * @example
 * var viewsManager = pivotTable.views;
 * viewsManager.save('config1');
 * viewsManager.get('config1');
 */
save(name:  string): boolean;
/**
 * @description get all views from pivot table views.
 * @example
 * var viewsManager = pivotTable.views;
 * viewsManager.save('config1');
 * console.log(viewsManager.all());
 */
all(): GC.Spread.Pivot.IPivotTableView[];
/**
 * @description apply a view to current pivot table.
 * @param {string} name Indicates the name of view to apply.
 * @example
 * var viewsManager = pivotTable.views;
 * viewsManager.save('config1');
 * viewsManager.apply('config1');
 */
apply(name:  string): void;
/**
 * @description get a view from pivot table views.
 * @param {string} name Indicates the name of view to query.
 * @example
 * var viewsManager = pivotTable.views;
 * viewsManager.save('config1');
 * viewsManager.get('config1');
 */
get(name:  string): GC.Spread.Pivot.IPivotTableView;
/**
 * @description remove a view from pivot table views.
 * @param {string} name Indicates the name of view to remove.
 * @example
 * var viewsManager = pivotTable.views;
 * viewsManager.remove('config1');
 * viewsManager.get('config1');
 */
remove(name:  string): void;

If you set "viewList" to visible in the pivot panel, you can use it to control the views of a PivotTable. You can add, remove, and apply the views with the view list section at the bottom of the panel.

You can follow these steps:

  • Click the "▼" button, which will show the views list dialog.
  • Click the "x" button on the right of each item in the views list dialog, which will remove the view.
  • Enter the View Name in the input dialog, and then click the "+" button to add the View.
  • If there is no value in the input dialog, the default name will be used instead.
  • Click one item in the views list dialog, and the view name will show in the input dialog.
  • Click the "√" button, which will apply the view with this name (with the Deserialize() API of PivotTable).
Views rely on the serialize() and deserialize() API to save and restore. Serialize & Deserialize Serialize current supports the following data: Fields Options Filter Sort Layout PivotTable Position Theme Interface API Sample Code PivotTableViewManager The PivotTableViewManager is used to add, delete, modify, and check Pivot Table Views. The PivotTableViewManager and PivotTable have a one-to-one relationship, and it is initialized in the PivotTable constructor. Interface API If you set "viewList" to visible in the pivot panel, you can use it to control the views of a PivotTable. You can add, remove, and apply the views with the view list section at the bottom of the panel. You can follow these steps: Click the "▼" button, which will show the views list dialog. Click the "x" button on the right of each item in the views list dialog, which will remove the view. Enter the View Name in the input dialog, and then click the "+" button to add the View. If there is no value in the input dialog, the default name will be used instead. Click one item in the views list dialog, and the view name will show in the input dialog. Click the "√" button, which will apply the view with this name (with the Deserialize() API of PivotTable).
import { Component, NgModule, enableProdMode } from '@angular/core'; import { BrowserModule } from '@angular/platform-browser'; import { platformBrowserDynamic } from '@angular/platform-browser-dynamic'; import { SpreadSheetsModule } from '@mescius/spread-sheets-angular'; import GC from '@mescius/spread-sheets'; import "@mescius/spread-sheets-shapes"; import "@mescius/spread-sheets-pivot-addon"; import './styles.css'; @Component({ selector: 'app-component', templateUrl: 'src/app.component.html' }) export class AppComponent { hostStyle = { width: 'calc(100% - 300px)', height: '100%', overflow: 'hidden', float: 'left' }; constructor() { } initSpread($event: any) { let spread = $event.spread; this.initSheets(spread); let pivotLayoutSheet = spread.getSheet(0); this.initPivotTable(pivotLayoutSheet); } initSheets (spread: GC.Spread.Sheets.Workbook) { spread.suspendPaint(); var sheet = spread.getSheet(1); sheet.name("DataSource"); sheet.setRowCount(117); sheet.setColumnWidth(0, 120); sheet.getCell(-1, 0).formatter("YYYY-mm-DD"); sheet.getRange(-1,4,0,2).formatter("$ #,##0"); let table = sheet.tables.add('tableSales', 0, 0, 117, 6); for(let i=2;i<=117;i++) { sheet.setFormula(i-1,5,'=D'+i+'*E'+i) } table.style(GC.Spread.Sheets.Tables.TableThemes["none"]); sheet.setArray(0, 0, pivotSales); var sheet0 = spread.getSheet(0); sheet0.name("PivotLayout"); sheet0.setValue(0, 1, "Switch the build-in views in the pivot panel view list."); spread.resumePaint(); } initPivotTable(sheet: GC.Spread.Sheets.WorkSheet) { var myPivotTable = sheet.pivotTables.add("myPivotTable", "tableSales", 2, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light8); myPivotTable.suspendLayout(); var groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }] }; myPivotTable.group(groupInfo); var emptyPT = "Empty Pivot Table"; myPivotTable.views.save(emptyPT); // Quarterly Report myPivotTable.options.showRowHeader = true; myPivotTable.options.showColumnHeader = true; myPivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField); myPivotTable.add("Quarters (date)", "Qt", GC.Spread.Pivot.PivotTableFieldType.columnField); myPivotTable.add("total", "Totals", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum); let styleItem = { dataOnly: true, references: [{ fieldName: "Qt", items: ["Qtr3", "Qtr4"] }] }; let style1 = new GC.Spread.Sheets.Style(); style1.formatter = '0%'; myPivotTable.setStyle(styleItem, style1); myPivotTable.views.save("Quarterly Report"); // Quantity Details myPivotTable.views.apply(emptyPT); myPivotTable.theme(GC.Spread.Pivot.PivotTableThemes.medium1); myPivotTable.options.insertBlankLineAfterEachItem = true; myPivotTable.options.mergeItem = true myPivotTable.layoutType(GC.Spread.Pivot.PivotTableLayoutType.tabular); myPivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField); myPivotTable.add("Quarters (date)", "Qt", GC.Spread.Pivot.PivotTableFieldType.columnField); myPivotTable.add("quantity", "Totals", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum); let style2 = new GC.Spread.Sheets.Style(); style1.formatter = '#,##0'; myPivotTable.setStyle(styleItem, style2); myPivotTable.views.save("Car Quantity Details"); // John Cars Report myPivotTable.views.apply(emptyPT); myPivotTable.options.subtotalPosition = 0; myPivotTable.layoutType(GC.Spread.Pivot.PivotTableLayoutType.compact); myPivotTable.theme(GC.Spread.Pivot.PivotTableThemes.light14); myPivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField); myPivotTable.add("car", "Cars", GC.Spread.Pivot.PivotTableFieldType.columnField); myPivotTable.add("Quarters (date)", "Qt", GC.Spread.Pivot.PivotTableFieldType.rowField); myPivotTable.add("total", "Totals", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum); var labelFilter = {textItem: {isAll: false, list: ["John"]}}; myPivotTable.labelFilter("Salesperson", labelFilter); let style3 = new GC.Spread.Sheets.Style(); style1.formatter = '$ #,##0'; myPivotTable.setStyle(styleItem, style3); myPivotTable.views.save("John Cars Report"); myPivotTable.views.apply("Quarterly Report"); new GC.Spread.Pivot.PivotPanel("myPivotPanel", myPivotTable, document.getElementById("panel")); myPivotTable.resumeLayout(); myPivotTable.autoFitColumn(); } } @NgModule({ imports: [BrowserModule, SpreadSheetsModule], declarations: [AppComponent], exports: [AppComponent], bootstrap: [AppComponent] }) export class AppModule {} enableProdMode(); // Bootstrap application with hash style navigation and global services. platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/spread/source/data/pivot-data.js" type="text/javascript"></script> <!-- Polyfills --> <script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script> <script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script> <!-- SystemJS --> <script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script> <script src="systemjs.config.js"></script> <script> // workaround to load 'rxjs/operators' from the rxjs bundle System.import('rxjs').then(function (m) { System.import('@angular/compiler'); System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators)); System.import('$DEMOROOT$/en/lib/angular/license.ts'); System.import('./src/app.component'); }); </script> </head> <body> <app-component></app-component> </body> </html>
<div class="sample-tutorial"> <gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)"> <gc-worksheet> </gc-worksheet> <gc-worksheet> </gc-worksheet> </gc-spread-sheets> <div class="sample-panel"> <div id="panel"></div> </div> </div>
.sample-tutorial { position: relative; height: 100%; } .sample-spreadsheets { width: calc(100% - 300px); height: 100%; overflow: hidden; float: left; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; overflow: hidden; } .sample-panel { float: right; width: 300px; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } .gc-panel { padding: 10px; background-color: rgb(230, 230, 230); } #panel { position: absolute; right: 0; width: 300px; height: 100%; top: 0; }
(function (global) { System.config({ transpiler: 'ts', typescriptOptions: { tsconfig: true }, meta: { 'typescript': { "exports": "ts" }, '*.css': { loader: 'css' } }, paths: { // paths serve as alias 'npm:': 'node_modules/' }, // map tells the System loader where to look for things map: { 'core-js': 'npm:core-js/client/shim.min.js', 'zone': 'npm:zone.js/fesm2015/zone.min.js', 'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js', '@angular/core': 'npm:@angular/core/fesm2022', '@angular/common': 'npm:@angular/common/fesm2022/common.mjs', '@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs', '@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs', '@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs', '@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs', '@angular/router': 'npm:@angular/router/fesm2022/router.mjs', '@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs', 'jszip': 'npm:jszip/dist/jszip.min.js', 'typescript': 'npm:typescript/lib/typescript.js', 'ts': './plugin.js', 'tslib':'npm:tslib/tslib.js', 'css': 'npm:systemjs-plugin-css/css.js', 'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js', 'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js', '@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js', '@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js', '@mescius/spread-sheets-pivot-addon': 'npm:@mescius/spread-sheets-pivot-addon/index.js', '@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs', '@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js' }, // packages tells the System loader how to load when no filename and/or no extension packages: { src: { defaultExtension: 'ts' }, rxjs: { defaultExtension: 'js' }, "node_modules": { defaultExtension: 'js' }, "node_modules/@angular": { defaultExtension: 'mjs' }, "@mescius/spread-sheets-angular": { defaultExtension: 'mjs' }, '@angular/core': { defaultExtension: 'mjs', main: 'core.mjs' } } }); })(this);

Pivot View Manager

The Pivot View Manager can be used to manage the saved views of a pivot table. It allows you to quickly access any saved view of the pivot table at a certain point in time. You can add, delete and modify the views in the pivot view manager.

Select a saved view from the 'Views' dropdown at the bottom of the pivot table panel then press the right checkmark next to it to change the view.

Description
app.vue
index.html
Copy to CodeMine

Views rely on the serialize() and deserialize() API to save and restore.

Serialize & Deserialize

Serialize current supports the following data:

  • Fields
  • Options
  • Filter
  • Sort
  • Layout
  • PivotTable Position
  • Theme

Interface

interface GC.Spread.Pivot.ISerializeInfo
{
    layoutType?: PivotTableLayoutType;
    options?: object;
    valuePosition?: GC.Pivot.IDataPosition;
    pivotTablePosition?: [number, number];
    fieldsInfo?: GC.Spread.Pivot.ISerializeFieldInfo[][];
}

interface GC.Spread.Pivot.ISerializeFieldInfo {
    sourceName: string;
    displayName: string;
    index: number;
    subtotal?:  GC.Pivot.SubtotalType;
    labelFilter?:  GC.Spread.Pivot.IPivotTextFilterInfo | GC.Spread.Pivot.IPivotConditionFilterInfo;
    valueFilter?:  GC.Spread.Pivot.IPivotConditionFilterInfo;
    sortInfo?:  GC.Spread.Pivot.IPivotTableSortInfo;
}

API

///* function serialize (): GC.Spread.Pivot.ISerializeInfo
/**
* @description get serialized pivot table data
* @returns {GC.Spread.Pivot.ISerializeInfo} serialized pivot table data
*/
serialize (): GC.Spread.Pivot.ISerializeInfo

///* function deserialize (serializeInfo: GC.Spread.Pivot.ISerializeInfo)
/**
* @description restore serialized pivot table data to a existed pivot table
* @param {GC.Spread.Pivot.ISerializeInfo} serialized pivot table data
*/
deserialize (serializeInfo: GC.Spread.Pivot.ISerializeInfo)

Sample Code

    var spread = new GC.Spread.Sheets.workbook(document.getElementById("ss"),{sheetCount:3});
    var sourceSheet = spread.getSheet(0);
    var sheet = spread.getSheet(1);
    var sourceData = [["Date","Buyer","Type","Amount"],
                      ["01-Jan","Mom","Fuel",74],
                      ["15-Jan","Mom","Food",235],
                      ["17-Jan","Dad","Sports",20],
                      ["21-Jan","Kelly","Books",125]];
    sourceSheet.setArray(0, 0, sourceData );
    sourceSheet.tables.add('sourceData', 0, 0, 5, 4);
    var layout = GC.Spread.Pivot.PivotTableLayoutType.compact;
    var theme = GC.Spread.Pivot.PivotTableThemes.medium2;
    var pivotTable = sheet.pivotTables.add("pivotTable_1", 'sourceData', 1, 1, layout, theme, options);
    pivotTable.add("Buyer","Buyer",GC.Spread.Pivot.PivotTableFieldType.rowField);
    pivotTable.add("Type","Type",GC.Spread.Pivot.PivotTableFieldType.columnField);
    pivotTable.add("Amount","Sum of Amount",GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
    var serialization = pivotTable.serialize();
    pivotTable.remove('Type');
    pivotTable.deserialize(serialization);

PivotTableViewManager

The PivotTableViewManager is used to add, delete, modify, and check Pivot Table Views.

The PivotTableViewManager and PivotTable have a one-to-one relationship, and it is initialized in the PivotTable constructor.

Interface

interface IPivotTableView{
     name: string;
     config: GC.Spread.Pivot.ISerializeInfo;
}

API

GC.Spread.Pivot.PivotTable
///* class GC.Spread.Pivot.PivotTable.PivotTableViewManager(applyCallback: Function, saveCallback: Function)
/**
 * Represents a PivotTableViewManager.
 * @class
 */
views

GC.Spread.Pivot.PivotTable.PivotTableViewManager
/**
 * @description Add a view to pivot table views. A unique name is required when adding a view.
 * @param {string} view Indicates the view to add.
 * @example
 * var viewsManager = pivotTable.views;
 * viewsManager.add({
 *      name: 'config1',
 *      config: pivotTable.serialize()
 * });
 * viewsManager.get('config1');
 */
add(view:  GC.Spread.Pivot.IPivotTableView): boolean;
/**
 * @description  Add a view to pivot table views. A unique name is required when adding a view.
 * @param {string} name Indicates the name of view to save.
 * @example
 * var viewsManager = pivotTable.views;
 * viewsManager.save('config1');
 * viewsManager.get('config1');
 */
save(name:  string): boolean;
/**
 * @description get all views from pivot table views.
 * @example
 * var viewsManager = pivotTable.views;
 * viewsManager.save('config1');
 * console.log(viewsManager.all());
 */
all(): GC.Spread.Pivot.IPivotTableView[];
/**
 * @description apply a view to current pivot table.
 * @param {string} name Indicates the name of view to apply.
 * @example
 * var viewsManager = pivotTable.views;
 * viewsManager.save('config1');
 * viewsManager.apply('config1');
 */
apply(name:  string): void;
/**
 * @description get a view from pivot table views.
 * @param {string} name Indicates the name of view to query.
 * @example
 * var viewsManager = pivotTable.views;
 * viewsManager.save('config1');
 * viewsManager.get('config1');
 */
get(name:  string): GC.Spread.Pivot.IPivotTableView;
/**
 * @description remove a view from pivot table views.
 * @param {string} name Indicates the name of view to remove.
 * @example
 * var viewsManager = pivotTable.views;
 * viewsManager.remove('config1');
 * viewsManager.get('config1');
 */
remove(name:  string): void;

If you set "viewList" to visible in the pivot panel, you can use it to control the views of a PivotTable. You can add, remove, and apply the views with the view list section at the bottom of the panel.

You can follow these steps:

  • Click the "▼" button, which will show the views list dialog.
  • Click the "x" button on the right of each item in the views list dialog, which will remove the view.
  • Enter the View Name in the input dialog, and then click the "+" button to add the View.
  • If there is no value in the input dialog, the default name will be used instead.
  • Click one item in the views list dialog, and the view name will show in the input dialog.
  • Click the "√" button, which will apply the view with this name (with the Deserialize() API of PivotTable).
Views rely on the serialize() and deserialize() API to save and restore. Serialize & Deserialize Serialize current supports the following data: Fields Options Filter Sort Layout PivotTable Position Theme Interface API Sample Code PivotTableViewManager The PivotTableViewManager is used to add, delete, modify, and check Pivot Table Views. The PivotTableViewManager and PivotTable have a one-to-one relationship, and it is initialized in the PivotTable constructor. Interface API If you set "viewList" to visible in the pivot panel, you can use it to control the views of a PivotTable. You can add, remove, and apply the views with the view list section at the bottom of the panel. You can follow these steps: Click the "▼" button, which will show the views list dialog. Click the "x" button on the right of each item in the views list dialog, which will remove the view. Enter the View Name in the input dialog, and then click the "+" button to add the View. If there is no value in the input dialog, the default name will be used instead. Click one item in the views list dialog, and the view name will show in the input dialog. Click the "√" button, which will apply the view with this name (with the Deserialize() API of PivotTable).
<template> <div class="sample-tutorial"> <gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread" > <gc-worksheet> </gc-worksheet> <gc-worksheet> </gc-worksheet> </gc-spread-sheets> <div class="sample-panel"> <div id="panel"></div> </div> </div> </template> <script setup> import GC from "@mescius/spread-sheets"; import "@mescius/spread-sheets-shapes"; import "@mescius/spread-sheets-vue"; import "@mescius/spread-sheets-pivot-addon"; function initSpread (spread) { initSheets(spread); let pivotLayoutSheet = spread.getSheet(0); initPivotTable(pivotLayoutSheet); } function initSheets (spread) { spread.suspendPaint(); var sheet = spread.getSheet(1); sheet.name("DataSource"); sheet.setRowCount(117); sheet.setColumnWidth(0, 120); sheet.getCell(-1, 0).formatter("YYYY-mm-DD"); sheet.getRange(-1,4,0,2).formatter("$ #,##0"); let table = sheet.tables.add('tableSales', 0, 0, 117, 6); for(let i=2;i<=117;i++) { sheet.setFormula(i-1,5,'=D'+i+'*E'+i) } table.style(GC.Spread.Sheets.Tables.TableThemes["none"]); sheet.setArray(0, 0, pivotSales); var sheet0 = spread.getSheet(0); sheet0.name("PivotLayout"); sheet0.setValue(0, 1, "Switch the build-in views in the pivot panel view list."); spread.resumePaint(); } function initPivotTable (sheet) { var myPivotTable = sheet.pivotTables.add("myPivotTable", "tableSales", 2, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light8); myPivotTable.suspendLayout(); var groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }] }; myPivotTable.group(groupInfo); var emptyPT = "Empty Pivot Table"; myPivotTable.views.save(emptyPT); // Quarterly Report myPivotTable.options.showRowHeader = true; myPivotTable.options.showColumnHeader = true; myPivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField); myPivotTable.add("Quarters (date)", "Qt", GC.Spread.Pivot.PivotTableFieldType.columnField); myPivotTable.add("total", "Totals", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum); let styleItem = { dataOnly: true, references: [{ fieldName: "Qt", items: ["Qtr3", "Qtr4"] }] }; let style1 = new GC.Spread.Sheets.Style(); style1.formatter = '0%'; myPivotTable.setStyle(styleItem, style1); myPivotTable.views.save("Quarterly Report"); // Quantity Details myPivotTable.views.apply(emptyPT); myPivotTable.theme(GC.Spread.Pivot.PivotTableThemes.medium1); myPivotTable.options.insertBlankLineAfterEachItem = true; myPivotTable.options.mergeItem = true myPivotTable.layoutType(GC.Spread.Pivot.PivotTableLayoutType.tabular); myPivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField); myPivotTable.add("Quarters (date)", "Qt", GC.Spread.Pivot.PivotTableFieldType.columnField); myPivotTable.add("quantity", "Totals", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum); let style2 = new GC.Spread.Sheets.Style(); style1.formatter = '#,##0'; myPivotTable.setStyle(styleItem, style2); myPivotTable.views.save("Car Quantity Details"); // John Cars Report myPivotTable.views.apply(emptyPT); myPivotTable.options.subtotalPosition = 0; myPivotTable.layoutType(GC.Spread.Pivot.PivotTableLayoutType.compact); myPivotTable.theme(GC.Spread.Pivot.PivotTableThemes.light14); let style3 = new GC.Spread.Sheets.Style(); style1.formatter = '$ #,##0'; myPivotTable.setStyle(styleItem, style3); myPivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField); myPivotTable.add("car", "Cars", GC.Spread.Pivot.PivotTableFieldType.columnField); myPivotTable.add("Quarters (date)", "Qt", GC.Spread.Pivot.PivotTableFieldType.rowField); myPivotTable.add("total", "Totals", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum); var labelFilter = {textItem: {isAll: false, list: ["John"]}}; myPivotTable.labelFilter("Salesperson", labelFilter); myPivotTable.views.save("John Cars Report"); myPivotTable.views.apply("Quarterly Report"); new GC.Spread.Pivot.PivotPanel("myPivotPanel", myPivotTable, document.getElementById("panel")); myPivotTable.resumeLayout(); myPivotTable.autoFitColumn(); } </script> <style scoped> .sample-tutorial { position: relative; height: 100%; } .sample-spreadsheets { width: calc(100% - 300px); height: 100%; overflow: hidden; float: left; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; overflow: hidden; } .sample-panel { float: right; width: 300px; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } .gc-panel { padding: 10px; background-color: rgb(230, 230, 230); } #panel { position: absolute; right: 0; width: 300px; height: 100%; top: 0; } #app { height: 100%; } </style>
<!DOCTYPE html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <title>SpreadJS VUE</title> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/spread/source/data/pivot-data.js" type="text/javascript"></script> <script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script> <script src="./systemjs.config.js"></script> <script src="./compiler.js" type="module"></script> <script> var System = SystemJS; System.import("./src/app.js"); System.import('$DEMOROOT$/en/lib/vue3/license.js'); </script> </head> <body> <div id="app"></div> </body> </html>
(function (global) { SystemJS.config({ transpiler: 'plugin-babel', babelOptions: { es2015: true }, paths: { // paths serve as alias 'npm:': 'node_modules/' }, packageConfigPaths: [ './node_modules/*/package.json', "./node_modules/@mescius/*/package.json", "./node_modules/@babel/*/package.json", "./node_modules/@vue/*/package.json" ], map: { 'vue': "npm:vue/dist/vue.esm-browser.js", 'tiny-emitter': 'npm:tiny-emitter/index.js', 'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js', "systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js", '@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js', '@mescius/spread-sheets-resources-en': 'npm:@mescius/spread-sheets-resources-en/index.js', '@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js', '@mescius/spread-sheets-pivot-addon': 'npm:@mescius/spread-sheets-pivot-addon/index.js', '@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js' }, meta: { '*.css': { loader: 'systemjs-plugin-css' }, '*.vue': { loader: "../plugin-vue/index.js" } } }); })(this);

Pivot View Manager

The Pivot View Manager can be used to manage the saved views of a pivot table. It allows you to quickly access any saved view of the pivot table at a certain point in time. You can add, delete and modify the views in the pivot view manager.

Select a saved view from the 'Views' dropdown at the bottom of the pivot table panel then press the right checkmark next to it to change the view.

Description
app.jsx
app-func.jsx
app-class.jsx
index.html
styles.css
Copy to CodeMine

Views rely on the serialize() and deserialize() API to save and restore.

Serialize & Deserialize

Serialize current supports the following data:

  • Fields
  • Options
  • Filter
  • Sort
  • Layout
  • PivotTable Position
  • Theme

Interface

interface GC.Spread.Pivot.ISerializeInfo
{
    layoutType?: PivotTableLayoutType;
    options?: object;
    valuePosition?: GC.Pivot.IDataPosition;
    pivotTablePosition?: [number, number];
    fieldsInfo?: GC.Spread.Pivot.ISerializeFieldInfo[][];
}

interface GC.Spread.Pivot.ISerializeFieldInfo {
    sourceName: string;
    displayName: string;
    index: number;
    subtotal?:  GC.Pivot.SubtotalType;
    labelFilter?:  GC.Spread.Pivot.IPivotTextFilterInfo | GC.Spread.Pivot.IPivotConditionFilterInfo;
    valueFilter?:  GC.Spread.Pivot.IPivotConditionFilterInfo;
    sortInfo?:  GC.Spread.Pivot.IPivotTableSortInfo;
}

API

///* function serialize (): GC.Spread.Pivot.ISerializeInfo
/**
* @description get serialized pivot table data
* @returns {GC.Spread.Pivot.ISerializeInfo} serialized pivot table data
*/
serialize (): GC.Spread.Pivot.ISerializeInfo

///* function deserialize (serializeInfo: GC.Spread.Pivot.ISerializeInfo)
/**
* @description restore serialized pivot table data to a existed pivot table
* @param {GC.Spread.Pivot.ISerializeInfo} serialized pivot table data
*/
deserialize (serializeInfo: GC.Spread.Pivot.ISerializeInfo)

Sample Code

    var spread = new GC.Spread.Sheets.workbook(document.getElementById("ss"),{sheetCount:3});
    var sourceSheet = spread.getSheet(0);
    var sheet = spread.getSheet(1);
    var sourceData = [["Date","Buyer","Type","Amount"],
                      ["01-Jan","Mom","Fuel",74],
                      ["15-Jan","Mom","Food",235],
                      ["17-Jan","Dad","Sports",20],
                      ["21-Jan","Kelly","Books",125]];
    sourceSheet.setArray(0, 0, sourceData );
    sourceSheet.tables.add('sourceData', 0, 0, 5, 4);
    var layout = GC.Spread.Pivot.PivotTableLayoutType.compact;
    var theme = GC.Spread.Pivot.PivotTableThemes.medium2;
    var pivotTable = sheet.pivotTables.add("pivotTable_1", 'sourceData', 1, 1, layout, theme, options);
    pivotTable.add("Buyer","Buyer",GC.Spread.Pivot.PivotTableFieldType.rowField);
    pivotTable.add("Type","Type",GC.Spread.Pivot.PivotTableFieldType.columnField);
    pivotTable.add("Amount","Sum of Amount",GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
    var serialization = pivotTable.serialize();
    pivotTable.remove('Type');
    pivotTable.deserialize(serialization);

PivotTableViewManager

The PivotTableViewManager is used to add, delete, modify, and check Pivot Table Views.

The PivotTableViewManager and PivotTable have a one-to-one relationship, and it is initialized in the PivotTable constructor.

Interface

interface IPivotTableView{
     name: string;
     config: GC.Spread.Pivot.ISerializeInfo;
}

API

GC.Spread.Pivot.PivotTable
///* class GC.Spread.Pivot.PivotTable.PivotTableViewManager(applyCallback: Function, saveCallback: Function)
/**
 * Represents a PivotTableViewManager.
 * @class
 */
views

GC.Spread.Pivot.PivotTable.PivotTableViewManager
/**
 * @description Add a view to pivot table views. A unique name is required when adding a view.
 * @param {string} view Indicates the view to add.
 * @example
 * var viewsManager = pivotTable.views;
 * viewsManager.add({
 *      name: 'config1',
 *      config: pivotTable.serialize()
 * });
 * viewsManager.get('config1');
 */
add(view:  GC.Spread.Pivot.IPivotTableView): boolean;
/**
 * @description  Add a view to pivot table views. A unique name is required when adding a view.
 * @param {string} name Indicates the name of view to save.
 * @example
 * var viewsManager = pivotTable.views;
 * viewsManager.save('config1');
 * viewsManager.get('config1');
 */
save(name:  string): boolean;
/**
 * @description get all views from pivot table views.
 * @example
 * var viewsManager = pivotTable.views;
 * viewsManager.save('config1');
 * console.log(viewsManager.all());
 */
all(): GC.Spread.Pivot.IPivotTableView[];
/**
 * @description apply a view to current pivot table.
 * @param {string} name Indicates the name of view to apply.
 * @example
 * var viewsManager = pivotTable.views;
 * viewsManager.save('config1');
 * viewsManager.apply('config1');
 */
apply(name:  string): void;
/**
 * @description get a view from pivot table views.
 * @param {string} name Indicates the name of view to query.
 * @example
 * var viewsManager = pivotTable.views;
 * viewsManager.save('config1');
 * viewsManager.get('config1');
 */
get(name:  string): GC.Spread.Pivot.IPivotTableView;
/**
 * @description remove a view from pivot table views.
 * @param {string} name Indicates the name of view to remove.
 * @example
 * var viewsManager = pivotTable.views;
 * viewsManager.remove('config1');
 * viewsManager.get('config1');
 */
remove(name:  string): void;

If you set "viewList" to visible in the pivot panel, you can use it to control the views of a PivotTable. You can add, remove, and apply the views with the view list section at the bottom of the panel.

You can follow these steps:

  • Click the "▼" button, which will show the views list dialog.
  • Click the "x" button on the right of each item in the views list dialog, which will remove the view.
  • Enter the View Name in the input dialog, and then click the "+" button to add the View.
  • If there is no value in the input dialog, the default name will be used instead.
  • Click one item in the views list dialog, and the view name will show in the input dialog.
  • Click the "√" button, which will apply the view with this name (with the Deserialize() API of PivotTable).
Views rely on the serialize() and deserialize() API to save and restore. Serialize & Deserialize Serialize current supports the following data: Fields Options Filter Sort Layout PivotTable Position Theme Interface API Sample Code PivotTableViewManager The PivotTableViewManager is used to add, delete, modify, and check Pivot Table Views. The PivotTableViewManager and PivotTable have a one-to-one relationship, and it is initialized in the PivotTable constructor. Interface API If you set "viewList" to visible in the pivot panel, you can use it to control the views of a PivotTable. You can add, remove, and apply the views with the view list section at the bottom of the panel. You can follow these steps: Click the "▼" button, which will show the views list dialog. Click the "x" button on the right of each item in the views list dialog, which will remove the view. Enter the View Name in the input dialog, and then click the "+" button to add the View. If there is no value in the input dialog, the default name will be used instead. Click one item in the views list dialog, and the view name will show in the input dialog. Click the "√" button, which will apply the view with this name (with the Deserialize() API of PivotTable).
import * as React from 'react'; import * as ReactDOM from 'react-dom'; import './styles.css'; import { AppFunc } from './app-func'; import { App } from './app-class'; // 1. Functional Component sample ReactDOM.render(<AppFunc />, document.getElementById('app')); // 2. Class Component sample // ReactDOM.render(<App />, document.getElementById('app'));
import * as React from 'react'; import GC from '@mescius/spread-sheets'; import "@mescius/spread-sheets-shapes"; import "@mescius/spread-sheets-pivot-addon"; import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react'; import './styles.css'; export function AppFunc() { const initSpread = (spread) => { initSheets(spread); let pivotLayoutSheet = spread.getSheet(0); initPivotTable(pivotLayoutSheet); } const initSheets = (spread) => { spread.suspendPaint(); var sheet = spread.getSheet(1); sheet.name("DataSource"); sheet.setRowCount(117); sheet.setColumnWidth(0, 120); sheet.getCell(-1, 0).formatter("YYYY-mm-DD"); sheet.getRange(-1, 4, 0, 2).formatter("$ #,##0"); let table = sheet.tables.add('tableSales', 0, 0, 117, 6); for (let i = 2; i <= 117; i++) { sheet.setFormula(i - 1, 5, '=D' + i + '*E' + i) } table.style(GC.Spread.Sheets.Tables.TableThemes["none"]); sheet.setArray(0, 0, pivotSales); var sheet0 = spread.getSheet(0); sheet0.name("PivotLayout"); sheet0.setValue(0, 1, "Switch the build-in views in the pivot panel view list."); spread.resumePaint(); } const initPivotTable = (sheet) => { var myPivotTable = sheet.pivotTables.add("myPivotTable", "tableSales", 2, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light8); myPivotTable.suspendLayout(); var groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }] }; myPivotTable.group(groupInfo); var emptyPT = "Empty Pivot Table"; myPivotTable.views.save(emptyPT); // Quarterly Report myPivotTable.options.showRowHeader = true; myPivotTable.options.showColumnHeader = true; myPivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField); myPivotTable.add("date", "Qt", GC.Spread.Pivot.PivotTableFieldType.columnField); myPivotTable.add("total", "Totals", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum); let styleItem = { dataOnly: true, references: [{ fieldName: "Qt", items: ["Qtr3", "Qtr4"] }] }; let style1 = new GC.Spread.Sheets.Style(); style1.formatter = '0%'; myPivotTable.setStyle(styleItem, style1); myPivotTable.views.save("Quarterly Report"); // Quantity Details myPivotTable.views.apply(emptyPT); myPivotTable.theme(GC.Spread.Pivot.PivotTableThemes.medium1); myPivotTable.options.insertBlankLineAfterEachItem = true; myPivotTable.options.mergeItem = true myPivotTable.layoutType(GC.Spread.Pivot.PivotTableLayoutType.tabular); myPivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField); myPivotTable.add("date", "Qt", GC.Spread.Pivot.PivotTableFieldType.columnField); myPivotTable.add("quantity", "Totals", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum); let style2 = new GC.Spread.Sheets.Style(); style1.formatter = '#,##0'; myPivotTable.setStyle(styleItem, style2); myPivotTable.views.save("Car Quantity Details"); // John Cars Report myPivotTable.views.apply(emptyPT); myPivotTable.options.subtotalPosition = 0; myPivotTable.layoutType(GC.Spread.Pivot.PivotTableLayoutType.compact); myPivotTable.theme(GC.Spread.Pivot.PivotTableThemes.light14); let style3 = new GC.Spread.Sheets.Style(); style1.formatter = '$ #,##0'; myPivotTable.setStyle(styleItem, style3); myPivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField); myPivotTable.add("car", "Cars", GC.Spread.Pivot.PivotTableFieldType.columnField); myPivotTable.add("date", "Qt", GC.Spread.Pivot.PivotTableFieldType.rowField); myPivotTable.add("total", "Totals", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum); var labelFilter = { textItem: { isAll: false, list: ["John"] } }; myPivotTable.labelFilter("Salesperson", labelFilter); myPivotTable.views.save("John Cars Report"); myPivotTable.views.apply("Quarterly Report"); new GC.Spread.Pivot.PivotPanel("myPivotPanel", myPivotTable, document.getElementById("panel")); myPivotTable.resumeLayout(); myPivotTable.autoFitColumn(); } return ( <div class="sample-tutorial"> <div class="sample-spreadsheets"> <SpreadSheets workbookInitialized={spread => initSpread(spread)}> <Worksheet> </Worksheet> <Worksheet> </Worksheet> </SpreadSheets> </div> <div class="sample-panel"> <div id="panel"></div> </div> </div> ); }
import * as React from 'react'; import GC from '@mescius/spread-sheets'; import "@mescius/spread-sheets-shapes"; import "@mescius/spread-sheets-pivot-addon"; import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react'; import './styles.css'; const Component = React.Component; export class App extends Component { render() { return ( <div class="sample-tutorial"> <div class="sample-spreadsheets"> <SpreadSheets workbookInitialized={spread=>this.initSpread(spread)}> <Worksheet> </Worksheet> <Worksheet> </Worksheet> </SpreadSheets> </div> <div class="sample-panel"> <div id="panel"></div> </div> </div> ); } initSpread(spread) { this.initSheets(spread); let pivotLayoutSheet = spread.getSheet(0); this.initPivotTable(pivotLayoutSheet); } initSheets (spread) { spread.suspendPaint(); var sheet = spread.getSheet(1); sheet.name("DataSource"); sheet.setRowCount(117); sheet.setColumnWidth(0, 120); sheet.getCell(-1, 0).formatter("YYYY-mm-DD"); sheet.getRange(-1,4,0,2).formatter("$ #,##0"); let table = sheet.tables.add('tableSales', 0, 0, 117, 6); for(let i=2;i<=117;i++) { sheet.setFormula(i-1,5,'=D'+i+'*E'+i) } table.style(GC.Spread.Sheets.Tables.TableThemes["none"]); sheet.setArray(0, 0, pivotSales); var sheet0 = spread.getSheet(0); sheet0.name("PivotLayout"); sheet0.setValue(0, 1, "Switch the build-in views in the pivot panel view list."); spread.resumePaint(); } initPivotTable(sheet) { var myPivotTable = sheet.pivotTables.add("myPivotTable", "tableSales", 2, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light8); myPivotTable.suspendLayout(); var groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }] }; myPivotTable.group(groupInfo); var emptyPT = "Empty Pivot Table"; myPivotTable.views.save(emptyPT); // Quarterly Report myPivotTable.options.showRowHeader = true; myPivotTable.options.showColumnHeader = true; myPivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField); myPivotTable.add("date", "Qt", GC.Spread.Pivot.PivotTableFieldType.columnField); myPivotTable.add("total", "Totals", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum); let styleItem = { dataOnly: true, references: [{ fieldName: "Qt", items: ["Qtr3", "Qtr4"] }] }; let style1 = new GC.Spread.Sheets.Style(); style1.formatter = '0%'; myPivotTable.setStyle(styleItem, style1); myPivotTable.views.save("Quarterly Report"); // Quantity Details myPivotTable.views.apply(emptyPT); myPivotTable.theme(GC.Spread.Pivot.PivotTableThemes.medium1); myPivotTable.options.insertBlankLineAfterEachItem = true; myPivotTable.options.mergeItem = true myPivotTable.layoutType(GC.Spread.Pivot.PivotTableLayoutType.tabular); myPivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField); myPivotTable.add("date", "Qt", GC.Spread.Pivot.PivotTableFieldType.columnField); myPivotTable.add("quantity", "Totals", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum); let style2 = new GC.Spread.Sheets.Style(); style1.formatter = '#,##0'; myPivotTable.setStyle(styleItem, style2); myPivotTable.views.save("Car Quantity Details"); // John Cars Report myPivotTable.views.apply(emptyPT); myPivotTable.options.subtotalPosition = 0; myPivotTable.layoutType(GC.Spread.Pivot.PivotTableLayoutType.compact); myPivotTable.theme(GC.Spread.Pivot.PivotTableThemes.light14); let style3 = new GC.Spread.Sheets.Style(); style1.formatter = '$ #,##0'; myPivotTable.setStyle(styleItem, style3); myPivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField); myPivotTable.add("car", "Cars", GC.Spread.Pivot.PivotTableFieldType.columnField); myPivotTable.add("date", "Qt", GC.Spread.Pivot.PivotTableFieldType.rowField); myPivotTable.add("total", "Totals", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum); var labelFilter = {textItem: {isAll: false, list: ["John"]}}; myPivotTable.labelFilter("Salesperson", labelFilter); myPivotTable.views.save("John Cars Report"); myPivotTable.views.apply("Quarterly Report"); new GC.Spread.Pivot.PivotPanel("myPivotPanel", myPivotTable, document.getElementById("panel")); myPivotTable.resumeLayout(); myPivotTable.autoFitColumn(); } }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/spread/source/data/pivot-data.js" type="text/javascript"></script> <!-- SystemJS --> <script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script> <script src="systemjs.config.js"></script> <script> System.import('$DEMOROOT$/en/lib/react/license.js').then(function () { System.import('./src/app'); }); </script> </head> <body> <div id="app"></div> </body> </html>
.sample-tutorial { position: relative; height: 100%; } .sample-spreadsheets { width: calc(100% - 300px); height: 100%; overflow: hidden; float: left; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; overflow: hidden; } .sample-panel { float: right; width: 300px; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } .gc-panel { padding: 10px; background-color: rgb(230, 230, 230); } #panel { position: absolute; right: 0; width: 300px; height: 100%; top: 0; } #app { height: 100%; }
(function (global) { System.config({ transpiler: 'plugin-babel', babelOptions: { es2015: true, react: true }, meta: { '*.css': { loader: 'css' } }, paths: { // paths serve as alias 'npm:': 'node_modules/' }, // map tells the System loader where to look for things map: { '@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js', '@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js', '@mescius/spread-sheets-pivot-addon': 'npm:@mescius/spread-sheets-pivot-addon/index.js', '@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js', '@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js', 'react': 'npm:react/umd/react.production.min.js', 'react-dom': 'npm:react-dom/umd/react-dom.production.min.js', 'css': 'npm:systemjs-plugin-css/css.js', 'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js', 'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js' }, // packages tells the System loader how to load when no filename and/or no extension packages: { src: { defaultExtension: 'jsx' }, "node_modules": { defaultExtension: 'js' }, } }); })(this);